using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;
using System.Threading;

namespace _B__Transfuzija_krvi
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            int[,] matrica = new int[n, 4];

            bool nemoguce = false;
            

            var ulaz = Console.ReadLine().Split();
            List<int> lista = new List<int>() { int.Parse(ulaz[0]), int.Parse(ulaz[1]), int.Parse(ulaz[2]), int.Parse(ulaz[3])};
            
            for (int i = 0; i < n; i++)
            {
                var u = Console.ReadLine().Split();

                int jedinica = int.Parse(u[1]);

                if (u[0] == "O" && nemoguce == false)
                {
                    if (lista[0] >= jedinica)
                    {
                        matrica[i, 0] = jedinica;
                        matrica[i, 1] = 0;
                        matrica[i, 2] = 0;
                        matrica[i, 3] = 0;

                        lista[0] -= jedinica;
                    }
                    else
                    {
                        nemoguce = true;
                    }
                }
                else if (u[0] == "A" && nemoguce == false)
                {
                    if (lista[1] >= jedinica)
                    {
                        matrica[i, 0] = 0;
                        matrica[i, 1] = jedinica;
                        matrica[i, 2] = 0;
                        matrica[i, 3] = 0;

                        lista[1] -= jedinica;
                    }
                    else if (lista[1] + lista[0] >= jedinica)
                    {
                        matrica[i, 0] = jedinica - lista[1];
                        matrica[i, 1] = lista[1];
                        matrica[i, 2] = 0;
                        matrica[i, 3] = 0;

                        lista[1] = 0;
                        lista[0] -= matrica[i, 0];
                    }
                    else
                    {
                        nemoguce = true;
                    }
                }
                else if(u[0] == "B" && nemoguce == false)
                {
                    if (lista[2] >= jedinica)
                    {
                        matrica[i, 0] = 0;
                        matrica[i, 1] = 0;
                        matrica[i, 2] = jedinica;
                        matrica[i, 3] = 0;

                        lista[2] -= jedinica;
                    }
                    else if (lista[2] + lista[0] >= jedinica)
                    {
                        matrica[i, 0] = jedinica - lista[2];
                        matrica[i, 1] = 0;
                        matrica[i, 2] = lista[2];
                        matrica[i, 3] = 0;

                        lista[2] = 0;
                        lista[0] -= matrica[i, 0];
                    }
                    else
                    {
                        nemoguce = true;
                    }
                }
                else if (u[0] == "AB" && nemoguce == false)
                {
                    if (lista[3] >= jedinica)
                    {
                        matrica[i, 0] = 0;
                        matrica[i, 1] = 0;
                        matrica[i, 2] = 0;
                        matrica[i, 3] = jedinica;

                        lista[3] -= jedinica;
                    }
                    else if (lista.Sum() >= jedinica)
                    {
                        if (lista[3] + lista[1] >= jedinica)
                        {
                            matrica[i, 0] = 0;
                            matrica[i, 1] = jedinica - lista[3];
                            matrica[i, 2] = 0;
                            matrica[i, 3] = lista[3];

                            lista[3] = 0;
                            lista[1] -= matrica[i, 1];

                        }
                        else if (lista[3] + lista[2] >= jedinica)
                        {
                            matrica[i, 0] = 0;
                            matrica[i, 1] = 0;
                            matrica[i, 2] = jedinica - lista[3];
                            matrica[i, 3] = lista[3];

                            lista[3] = 0;
                            lista[2] -= matrica[i, 2];
                        }
                        else if (lista[3] + lista[2] + lista[1] >= jedinica)
                        {
                            matrica[i, 0] = 0;
                            matrica[i, 1] = lista[1];
                            matrica[i, 2] = jedinica - lista[3] - lista[1];
                            matrica[i, 3] = lista[3];

                            lista[1] = 0;
                            lista[3] = 0;
                            lista[2] -= matrica[i, 2];

                        }
                        else
                        {
                            matrica[i, 0] = jedinica - lista[3] - lista[2] - lista[1];
                            matrica[i, 1] = lista[1];
                            matrica[i, 2] = lista[2];
                            matrica[i, 3] = lista[3];

                            lista[3] = 0;
                            lista[2] = 0;
                            lista[1] = 0;
                            lista[0] -= matrica[i, 0];
                        }
                    }
                    else
                    {
                        nemoguce = true;
                    }
                }
            }

            if (nemoguce)
            {
                Console.WriteLine("nemoguce");
                return;
            }

            Console.WriteLine("moguce");

            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    Console.Write(matrica[i, j] + " ");
                }
                Console.WriteLine();
            }
        }
    }
}